diff --git a/Makefile.am b/Makefile.am
index 8960aecc..1949b7f8 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -173,6 +173,8 @@ TESTS = fwts-test/acpidump-0001/test-0001.sh \
 	fwts-test/pmtt-0001/test-0002.sh \
 	fwts-test/pptt-0001/test-0001.sh \
 	fwts-test/pptt-0001/test-0002.sh \
+	fwts-test/ras2-0001/test-0001.sh \
+	fwts-test/ras2-0001/test-0002.sh \
 	fwts-test/rasf-0001/test-0001.sh \
 	fwts-test/rasf-0001/test-0002.sh \
 	fwts-test/rgrt-0001/test-0001.sh \
diff --git a/fwts-test/ras2-0001/acpidump-0001.log b/fwts-test/ras2-0001/acpidump-0001.log
new file mode 100644
index 00000000..425f4e38
--- /dev/null
+++ b/fwts-test/ras2-0001/acpidump-0001.log
@@ -0,0 +1,31 @@
+FACS @ 0x00000000
+  0000: 46 41 43 53 40 00 00 00 00 00 00 00 00 00 00 00  FACS@...........
+  0010: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  0020: 01 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  0030: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  0040: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+
+FACP @ 0x00000000
+  0000: 46 41 43 50 f4 00 00 00 03 f9 41 4d 44 20 20 20  FACP......AMD   
+  0010: 47 55 41 4d 20 20 20 20 00 00 04 06 41 4d 44 20  GUAM    ....AMD 
+  0020: 40 42 0f 00 c0 2f e9 af 92 47 e8 af 00 02 09 00  @B.../...G......
+  0030: b0 00 00 00 f0 f1 00 00 00 80 00 00 00 00 00 00  ................
+  0040: 04 80 00 00 00 00 00 00 00 82 00 00 08 80 00 00  ................
+  0050: 20 80 00 00 00 00 00 00 04 02 01 04 08 00 00 00   ...............
+  0060: 65 00 e9 03 00 00 00 00 01 00 0d 00 32 00 00 00  e...........2...
+  0070: a5 c1 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  0080: 00 00 00 00 c0 2f e9 af 00 00 00 00 92 47 e8 af  ...../.......G..
+  0090: 00 00 00 00 01 20 00 00 00 80 00 00 00 00 00 00  ..... ..........
+  00a0: 00 00 00 00 00 00 00 00 00 00 00 00 01 10 00 00  ................
+  00b0: 04 80 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  00c0: 00 00 00 00 01 08 00 00 00 82 00 00 00 00 00 00  ................
+  00d0: 01 20 00 00 08 80 00 00 00 00 00 00 01 40 00 00  . ...........@..
+  00e0: 20 80 00 00 00 00 00 00 00 00 00 00 00 00 00 00   ...............
+  00f0: 00 00 00 00                                      ....
+
+RAS2 @ 0x0000000000000000
+  0000: 52 41 53 32 38 00 00 00 01 28 49 4E 54 45 4C 20  RAS28....(INTEL 
+  0010: 54 65 6D 70 6C 61 74 65 01 00 00 00 49 4E 54 4C  Template....INTL
+  0020: 28 06 23 20 00 00 02 00 00 00 00 00 01 00 00 00  (.# ............
+  0030: 01 00 00 00 02 00 00 00                          ........
+
diff --git a/fwts-test/ras2-0001/acpidump-0002.log b/fwts-test/ras2-0001/acpidump-0002.log
new file mode 100644
index 00000000..94d881d6
--- /dev/null
+++ b/fwts-test/ras2-0001/acpidump-0002.log
@@ -0,0 +1,31 @@
+FACS @ 0x00000000
+  0000: 46 41 43 53 40 00 00 00 00 00 00 00 00 00 00 00  FACS@...........
+  0010: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  0020: 01 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  0030: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  0040: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+
+FACP @ 0x00000000
+  0000: 46 41 43 50 f4 00 00 00 03 f9 41 4d 44 20 20 20  FACP......AMD   
+  0010: 47 55 41 4d 20 20 20 20 00 00 04 06 41 4d 44 20  GUAM    ....AMD 
+  0020: 40 42 0f 00 c0 2f e9 af 92 47 e8 af 00 02 09 00  @B.../...G......
+  0030: b0 00 00 00 f0 f1 00 00 00 80 00 00 00 00 00 00  ................
+  0040: 04 80 00 00 00 00 00 00 00 82 00 00 08 80 00 00  ................
+  0050: 20 80 00 00 00 00 00 00 04 02 01 04 08 00 00 00   ...............
+  0060: 65 00 e9 03 00 00 00 00 01 00 0d 00 32 00 00 00  e...........2...
+  0070: a5 c1 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  0080: 00 00 00 00 c0 2f e9 af 00 00 00 00 92 47 e8 af  ...../.......G..
+  0090: 00 00 00 00 01 20 00 00 00 80 00 00 00 00 00 00  ..... ..........
+  00a0: 00 00 00 00 00 00 00 00 00 00 00 00 01 10 00 00  ................
+  00b0: 04 80 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................
+  00c0: 00 00 00 00 01 08 00 00 00 82 00 00 00 00 00 00  ................
+  00d0: 01 20 00 00 08 80 00 00 00 00 00 00 01 40 00 00  . ...........@..
+  00e0: 20 80 00 00 00 00 00 00 00 00 00 00 00 00 00 00   ...............
+  00f0: 00 00 00 00                                      ....
+
+RAS2 @ 0x0000000000000000
+  0000: 52 41 53 32 38 00 00 00 01 28 49 4E 54 45 4C 20  RAS28....(INTEL 
+  0010: 54 65 6D 70 6C 61 74 65 01 00 00 00 49 4E 54 4C  Template....INTL
+  0020: 28 06 23 20 00 00 02 00 00 00 FF 3F 01 00 00 00  (.# ............
+  0030: 01 11 00 7F 02 00 00 00                          ........
+
diff --git a/fwts-test/ras2-0001/ras2-0001.log b/fwts-test/ras2-0001/ras2-0001.log
new file mode 100644
index 00000000..7ada1575
--- /dev/null
+++ b/fwts-test/ras2-0001/ras2-0001.log
@@ -0,0 +1,22 @@
+ras2            ras2: ACPI RAS2 Feature Table test
+ras2            ----------------------------------------------------------
+ras2            Test 1 of 1: Validate RAS2 table.
+ras2            RAS2 (ACPI RAS2 Feature) Table:
+ras2              Reserved:                  0x0000
+ras2              Number of PCC descriptors: 0x0002
+ras2              PCC Descriptor List:
+ras2                PCC Identifier:          0x00
+ras2                Reserved:                0x0000
+ras2                Feature Type:            0x00
+ras2                Instance:                0x00000001
+ras2              PCC Descriptor List:
+ras2                PCC Identifier:          0x01
+ras2                Reserved:                0x0000
+ras2                Feature Type:            0x00
+ras2                Instance:                0x00000002
+ras2            PASSED: Test 1, No issues found in RAS2 table.
+ras2            
+ras2            ==========================================================
+ras2            1 passed, 0 failed, 0 warning, 0 aborted, 0 skipped, 0
+ras2            info only.
+ras2            ==========================================================
diff --git a/fwts-test/ras2-0001/ras2-0002.log b/fwts-test/ras2-0001/ras2-0002.log
new file mode 100644
index 00000000..90703315
--- /dev/null
+++ b/fwts-test/ras2-0001/ras2-0002.log
@@ -0,0 +1,29 @@
+ras2            ras2: ACPI RAS2 Feature Table test
+ras2            ----------------------------------------------------------
+ras2            Test 1 of 1: Validate RAS2 table.
+ras2            RAS2 (ACPI RAS2 Feature) Table:
+ras2              Reserved:                  0x0000
+ras2              Number of PCC descriptors: 0x0002
+ras2              PCC Descriptor List:
+ras2                PCC Identifier:          0x00
+ras2                Reserved:                0xff00
+ras2                Feature Type:            0x3f
+ras2                Instance:                0x00000001
+ras2            FAILED [MEDIUM] RAS2ReservedNonZero: Test 1, RAS2 Reserved
+ras2            field must be zero, got 0xff00 instead
+ras2            FAILED [HIGH] RAS2ReservedType: Test 1, RAS2 RAS feature
+ras2            types 0x01-0x7f is reserved, got 0x3f
+ras2              PCC Descriptor List:
+ras2                PCC Identifier:          0x01
+ras2                Reserved:                0x0011
+ras2                Feature Type:            0x7f
+ras2                Instance:                0x00000002
+ras2            FAILED [MEDIUM] RAS2ReservedNonZero: Test 1, RAS2 Reserved
+ras2            field must be zero, got 0x0011 instead
+ras2            FAILED [HIGH] RAS2ReservedType: Test 1, RAS2 RAS feature
+ras2            types 0x01-0x7f is reserved, got 0x7f
+ras2            
+ras2            ==========================================================
+ras2            0 passed, 4 failed, 0 warning, 0 aborted, 0 skipped, 0
+ras2            info only.
+ras2            ==========================================================
diff --git a/fwts-test/ras2-0001/test-0001.sh b/fwts-test/ras2-0001/test-0001.sh
new file mode 100755
index 00000000..9754bc40
--- /dev/null
+++ b/fwts-test/ras2-0001/test-0001.sh
@@ -0,0 +1,23 @@
+#!/bin/bash
+#
+TEST="Test acpitables against RAS2"
+NAME=test-0001.sh
+TMPLOG=$TMP/ras2.log.$$
+
+$FWTS --show-tests | grep sdev > /dev/null
+if [ $? -eq 1 ]; then
+	echo SKIP: $TEST, $NAME
+	exit 77
+fi
+
+$FWTS --log-format="%line %owner " -w 80 --dumpfile=$FWTSTESTDIR/ras2-0001/acpidump-0001.log ras2 - | cut -c7- | grep "^ras2" > $TMPLOG
+diff $TMPLOG $FWTSTESTDIR/ras2-0001/ras2-0001.log >> $FAILURE_LOG
+ret=$?
+if [ $ret -eq 0 ]; then
+	echo PASSED: $TEST, $NAME
+else
+	echo FAILED: $TEST, $NAME
+fi
+
+rm $TMPLOG
+exit $ret
diff --git a/fwts-test/ras2-0001/test-0002.sh b/fwts-test/ras2-0001/test-0002.sh
new file mode 100755
index 00000000..687b7d94
--- /dev/null
+++ b/fwts-test/ras2-0001/test-0002.sh
@@ -0,0 +1,23 @@
+#!/bin/bash
+#
+TEST="Test acpitables against RAS2"
+NAME=test-0002.sh
+TMPLOG=$TMP/ras2.log.$$
+
+$FWTS --show-tests | grep sdev > /dev/null
+if [ $? -eq 1 ]; then
+	echo SKIP: $TEST, $NAME
+	exit 77
+fi
+
+$FWTS --log-format="%line %owner " -w 80 --dumpfile=$FWTSTESTDIR/ras2-0001/acpidump-0002.log ras2 - | cut -c7- | grep "^ras2" > $TMPLOG
+diff $TMPLOG $FWTSTESTDIR/ras2-0001/ras2-0002.log >> $FAILURE_LOG
+ret=$?
+if [ $ret -eq 0 ]; then
+	echo PASSED: $TEST, $NAME
+else
+	echo FAILED: $TEST, $NAME
+fi
+
+rm $TMPLOG
+exit $ret